%PROGRAM PRO RESENI VICENASOBNYCH PORUCH
clear all
a=exp(2*j*pi/3);                          % posuv o 120 stup.
A=[1 1 1;1 conj(a) a;1 a conj(a)];        % transforman matice
E2=[1; conj(a); a]; E0=[1; a; conj(a)];   % matice prevod
SBase=1;                                  % Vztan vkon
I1Pd=[];I2Pd=[];I0Pd=[];                  % dod. proudy mst poruch
I1Pbas=[];I2Pbas=[];I0Pbas=[];            % bazov proudy poruch
vstup;                                    % Naten vstupnch dat
Y1=Ymat(ZU,KU,R,X,B,T,YU1);	      % Sestaveni sousledne Y matice 
Y2=Ymat(ZU,KU,R,X,B,conj(T),YU2);     % Sestaveni zptn Y matice 
Y0=Ymat(ZU,KU,R0,X0,B0,T,YU0);          % Sestaveni nulov Y matice 
Nf=size(K,1);,NU=size(Y1,1);            % poet poruch a poet uzl
Z1=inv(Y1);Z2=inv(Y2);Z0=inv(Y0);        %impedancni matice 1,2,0
I1=IG;I2= zeros(NU,1);I0=zeros(NU,1);  %Vychozi uzlov proudy 1,2,0
U1=Z1*I1;,U2=Z2*I2;,U0=Z0*I0; 	       %Vychozi uzlov napeti 1,2,0
for f=1: Nf,
	E2d(f,f)=E2(FAZE(f));,E0d(f,f)=E0(FAZE(f)); % pevody pom.traf
   %tvorba slokovych poruchovych matic
   	Z1P(f,f)=ZF(Z1,K,L,f,f); %diag. prvek  1
   	Z2P(f,f)=ZF(Z2,K,L,f,f); %diag. prvek  2
   	Z0P(f,f)=ZF(Z0,K,L,f,f); %diag. prvek  0
   for ff=1:f-1                  % cyklus pro nediagonalni prvky
      Z1P(ff,f)=ZF(Z1,K,L,ff,f);Z1P(f,ff)=ZF(Z1,K,L,f,ff);%sousl.
      Z2P(ff,f)=ZF(Z2,K,L,ff,f);Z2P(f,ff)=ZF(Z2,K,L,f,ff);%zpet.
      Z0P(ff,f)=ZF(Z0,K,L,ff,f);Z0P(f,ff)=ZF(Z0,K,L,f,ff);%nul.
   end 
 end
bazvel;              %bzove veliiny mst poruch ped poruchou
Zpom=E2d*Z2P*inv(E2d)+E0d*Z0P*inv(E0d);         %pomocn matice
Z_res=Z1P+Zpom;                           %rezultujc matice Z
Upom=E2d*Z2P*I2Pbas+E0d*Z0P*I0Pbas-(U1Pbas+E2d*U2Pbas+E0d*U0Pbas);
U_res=Upom-Zpom*I1Pbas;             %rezultujc napt
I1Pd=inv(Z_res)*U_res;   %Dodatkov proud mst poruch sousledn           
I1P=I1Pbas+I1Pd;          %Celkov proud mst  poruch sousledn 
I2Pd=inv(E2d)*I1P-I2Pbas;        %Dodatkov proud poruch zptn 
I0Pd=inv(E0d)*I1P-I0Pbas;        %Dodatkov proud poruch nulov 	
I1d=alok(I1Pd,K,L,NU,f);             %Dodatkov proudy v uzlech 
I2d=alok(I2Pd,K,L,NU,f);               I0d=alok(I0Pd,K,L,NU,f);
U1d=Z1*I1d;U2d=Z2*I2d;U0d=Z0*I0d;  %slokov zmny uzlovch  napt
U1=U1+U1d; U2=U2+U2d; U0=U0+U0d;   %vysledna slokov napt uzl
%..............................................................